#include <stdio.h>
#include "vimcode.h"
#include "v2a.h"

static char *codetable[]= {
"	L%s:\n",
"// abs_\n"
"		call	abs\n"
"		add	esp, 4\n",
"// add\n"
"		pop	eax\n"
"		add	[esp], eax\n",
"// and\n"
"		pop	eax\n"
"		and	[esp], eax\n",
"// call\n"
"		xcall(R%d, L%s)\n"
"	R%d:\n",
"// crseg\n"
"		push	SEGLEN%s\n"
"		push	%s\n"
"		call	crseg\n"
"		add	esp, 8\n",
"// descr\n"
"		descr(%s, %s, %s)\n",
"// dlseg\n"
"		call	dlseg\n",
"// dvi\n"
"		pop	ebx\n"
"		mov	eax, [esp]\n"
"		cdq\n"
"		idiv	ebx\n"
"		mov	[esp], eax\n",
"// eq\n"
"		pop	eax\n"
"		xor	ecx, ecx\n"
"		cmp	eax, [esp]\n"
"		sete	cl\n"
"		mov	[esp], ecx\n",
"// eqn\n"
"		pop	eax\n"
"		eqn(eax, %s, %s)\n"
"		push	eax\n",
"// ge\n"
"		pop	eax\n"
"		xor	ecx, ecx\n"
"		cmp	eax, [esp]\n"
"		setle	cl\n"
"		mov	[esp], ecx\n",
"// gt\n"
"		pop	eax\n"
"		xor	ecx, ecx\n"
"		cmp	eax, [esp]\n"
"		setl	cl\n"
"		mov	[esp], ecx\n",
"// halt\n"
"		push	0\n"
"		call	exit\n",
"// jiff\n"
"		pop	eax\n"
"		test	eax, eax\n"
"		je	L%s\n",
"// jift\n"
"		pop	eax\n"
"		test	eax, eax\n"
"		jne	L%s\n",
"// jump\n"
"		jmp	L%s\n",
"// ldcon\n"
"		push	%s\n",
"// ldind\n"
"		push	[esp]\n"
"		call	getmema\n"
"		add	esp, 4\n"
"		push	eax\n",
"// ldnvar\n"
"		ldnvar(%s, %s)\n",
"// ldvar\n"
"		push	%s\n"
"		push	%s\n"
"		call	getmemr\n"
"		add	esp, 8\n"
"		push	eax\n",
"// ldxvar\n"
"		ixdpl(%s, %s)\n"
"		push	%s\n"
"		call	getmemr\n"
"		add	esp, 8\n"
"		push	eax\n",
"// le\n"
"		pop	eax\n"
"		xor	ecx, ecx\n"
"		cmp	eax, [esp]\n"
"		setge	cl\n"
"		mov	[esp], ecx\n",
"// lt\n"
"		pop	eax\n"
"		xor	ecx, ecx\n"
"		cmp	eax, [esp]\n"
"		setg	cl\n"
"		mov	[esp], ecx\n",
"// mdl\n"
"		pop	ebx\n"
"		mov	eax, [esp]\n"
"		cdq\n"
"		idiv	ebx\n"
"		mov	[esp], edx\n",
"// mul\n"
"		pop	eax\n"
"		imul	eax, [esp]\n"
"		mov	[esp], eax\n",
"// ne\n"
"		pop	eax\n"
"		xor	ecx, ecx\n"
"		cmp	eax, [esp]\n"
"		setne	cl\n"
"		mov	[esp], ecx\n",
"// neg\n"
"		pop	eax\n"
"		neg	eax\n"
"		push	eax\n",
"// nen\n"
"		pop	eax\n"
"		eqn(eax, %s, %s)\n"
"		neg	eax\n"
"		sbb	eax, eax\n"
"		inc	eax\n"
"		push	eax\n",
"// noop\n"
"		nop\n",
"// not\n"
"		pop	eax\n"
"		neg	eax\n"
"		sbb	eax, eax\n"
"		inc	eax\n"
"		push	eax\n",
"// or\n"
"		pop	eax\n"
"		or	[esp], eax\n",
"// pop\n"
"		pop	eax\n",
"// popn\n"
"		popn(%s, %s)\n",
"// rdbool\n"
"		call	rdbool	 \n"
"		push	eax\n",
"// rdchar\n"
"		call	rdchar	 \n"
"		push	eax\n",
"// rdint\n"
"		call	rdint	 \n"
"		push	eax\n",
"// rdstring\n"
"		push	STRTABSIZE\n"
"		call	rdstring\n"
"		add	esp, 4\n"
"		push	eax\n",
"// return_\n"
"		call	asreturn_\n"
"		jmp	eax\n",
"// stind\n"
"		call	putmema\n"
"		add	esp, 4\n",
"// stnvar\n"
"		stnvar(%s, %s)\n",
"// stvar\n"
"		push	%s\n"
"		push	%s\n"
"		call	putmemr\n"
"		add	esp, 12\n",
"// stxvar\n"
"		ixdpl(%s, %s)\n"
"		push	%s\n"
"		call	putmemr\n"
"		add	esp, 12\n",
"// sub\n"
"		pop	eax\n"
"		neg	eax\n"
"		add	[esp], eax\n",
"// swap\n"
"		pop	eax\n"
"		pop	ebx\n"
"		push	eax\n"
"		push	ebx\n",
"// varaddr\n"
"		push	%s\n"
"		push	%s\n"
"		call	varaddr\n"
"		add	esp, 8\n"
"		push	eax\n",
"// wrbool\n"
"		call	wrbool\n",
"// wrchar\n"
"		call	wrchar\n",
"// wrint\n"
"		call	wrint\n",
"// wrstring\n"
"		push	STRTABSIZE\n"
"		call	wrstring\n"
"		add	esp, 4\n",
"// xvaraddr\n"
"		ixdpl(%s, %s)\n"
"		push	%s\n"
"		call	varaddr\n"
"		add	esp, 8\n"
"		push	eax\n",
};

static FILE			*GenFp, *LtFp, *StFp;
static char			LtFname[]= "lentab.h", StFname[]= "strtab.h";

#define MAX_STRINGS	250	/* maximum number of strings */

void
startcode(void)
{
	string	filename;
	char	*ext, *basename;

	/* strip leading path */
	if ((basename= strrchr(i_input_name, '/')) != 0)
		basename++;
	else
		basename= i_input_name;

	/* replace or add .c extension */
	if ((ext= strrchr(basename, '.')) != 0)
		sprintf(filename, "%.*s.c", (int)(ext-basename), basename);
	else
		sprintf(filename, "%s.c", basename);

	fprintf(stderr, "- generating     : %s\n", filename);

	if ((GenFp= fopen(filename, "w")) == 0) {
		printf("File '%s' not writeable\n", filename);
		exit(1);
	}

	fprintf(GenFp, "#include \"extmac.h\"\t// include array/call macros\n");
	fprintf(GenFp, "#include \"%s\"\t// include segment length macros\n"
	, LtFname);
	fprintf(GenFp, "#include \"%s\"\t// include string table\n", StFname);

	fputs("\nvoid main(void)\n{\n", GenFp);
	fputs("\t__asm\n\t{\n", GenFp);
}

void
emitcode(opcode opc, string arg1, string arg2, string arg3)
{
	static int	returnlabel= 1;

	switch (opc) {
	case call_opc:
		fprintf(GenFp, codetable[opc], returnlabel, arg1, returnlabel);
		returnlabel++;
		break;
	case ldxvar_opc:
	case stxvar_opc:
	case xvaraddr_opc:
		fprintf(GenFp, codetable[opc], arg1, arg2, arg1);
		break;
	case crseg_opc:
	case ldvar_opc:
	case stvar_opc:
	case varaddr_opc:
		fprintf(GenFp, codetable[opc], arg2, arg1, arg3);
		break;
	default:
		fprintf(GenFp, codetable[opc], arg1, arg2, arg3);
	}
}

void
finishcode(void)
{
	fputs("\t}\n}\n", GenFp);
	fclose(GenFp);
}

void
startlentab(void)
{
	if ((LtFp= fopen(LtFname, "w")) == 0) {
		perror(LtFname);
		exit(1);
	}
}

void
emitlen(string index, string len)
{
	fprintf(LtFp, "#define SEGLEN%s %s\n", index, len);
}

void
finishlentab(void)
{
	fclose(LtFp);
}

void
startstrtab(void)
{
	if ((StFp= fopen(StFname, "w")) == 0) {
		perror(StFname);
		exit(1);
	}
	fputs("char *StringTab[]= {\n", StFp);
}

void
emitstr(string index, string str)
{
	fprintf(StFp, "\t%s,\n", str);
}

void
finishstrtab(void)
{
	fputs("\t0\n};\n", StFp);
	fputs("static int STRTABSIZE=(sizeof StringTab/sizeof StringTab[0])-1;\n"
	, StFp);
	fclose(StFp);
}

#ifdef TEST
char	i_input_name[]= "test.c";

int
main(void)
{
	startcode();
	emitcode(label_nr, "1", NULL, NULL);
	emitcode(abs_opc, NULL, NULL, NULL);
	emitcode(add_opc, NULL, NULL, NULL);
	emitcode(and_opc, NULL, NULL, NULL);
	emitcode(call_opc, "1", NULL, NULL);
	emitcode(crseg_opc, "1", "1", NULL);
	emitcode(descr_opc, "1", "0", "3");
	emitcode(dlseg_opc, NULL, NULL, NULL);
	emitcode(dvi_opc, NULL, NULL, NULL);
	emitcode(eq_opc, NULL, NULL, NULL);
	emitcode(eqn_opc, "1", "0", NULL);
	emitcode(ge_opc, NULL, NULL, NULL);
	emitcode(gt_opc, NULL, NULL, NULL);
	emitcode(jiff_opc, "1", NULL, NULL);
	emitcode(jift_opc, "1", NULL, NULL);
	emitcode(jump_opc, "1", NULL, NULL);
	emitcode(ldcon_opc, "1", NULL, NULL);
	emitcode(ldind_opc, NULL, NULL, NULL);
	emitcode(ldnvar_opc, "1", "0", NULL);
	emitcode(ldvar_opc, "1", "0", NULL);
	emitcode(ldxvar_opc, "1", "0", "1");
	emitcode(le_opc, NULL, NULL, NULL);
	emitcode(lt_opc, NULL, NULL, NULL);
	emitcode(mdl_opc, NULL, NULL, NULL);
	emitcode(mul_opc, NULL, NULL, NULL);
	emitcode(ne_opc, NULL, NULL, NULL);
	emitcode(neg_opc, NULL, NULL, NULL);
	emitcode(nen_opc, "1", "0", NULL);
	emitcode(no_opc, NULL, NULL, NULL);
	emitcode(not_opc, NULL, NULL, NULL);
	emitcode(or_opc, NULL, NULL, NULL);
	emitcode(pop_opc, NULL, NULL, NULL);
	emitcode(popn_opc, "1", "0", NULL);
	emitcode(rdbool_opc, NULL, NULL, NULL);
	emitcode(rdchar_opc, NULL, NULL, NULL);
	emitcode(rdint_opc, NULL, NULL, NULL);
	emitcode(rdstring_opc, NULL, NULL, NULL);
	emitcode(return_opc, NULL, NULL, NULL);
	emitcode(stind_opc, NULL, NULL, NULL);
	emitcode(stnvar_opc, "1", "0", NULL);
	emitcode(stvar_opc, "1", "0", NULL);
	emitcode(stxvar_opc, "1", "0", "1");
	emitcode(sub_opc, NULL, NULL, NULL);
	emitcode(swap_opc, NULL, NULL, NULL);
	emitcode(varaddr_opc, "1", "0", NULL);
	emitcode(wrbool_opc, NULL, NULL, NULL);
	emitcode(wrchar_opc, NULL, NULL, NULL);
	emitcode(wrint_opc, NULL, NULL, NULL);
	emitcode(wrstring_opc, NULL, NULL, NULL);
	emitcode(xvaraddr_opc, "1", "0", "1");
	emitcode(halt_opc, NULL, NULL, NULL);
	startlentab();
	emitlen("1", "2");
	finishlentab();
	startstrtab();
	emitstr(NULL, "\"This is a string\"");
	finishstrtab();
	return 0;
}
#endif

