#include <stdio.h>
#include "vimcode.h"

char *codetable[]= {
/* label */
"	l_%s:\n",
"/* abs_ */\n"
"		push(abs(pop()));\n",
"/* add */\n"
"		push(pop() + pop());\n",
"/* and */\n"
"		push(pop() & pop());\n",
"/* call */\n"
"		{ jmp_buf jmpbuf;\n"
"		  if (setjmp(jmpbuf) == 0) {\n"
"		    ccall(&jmpbuf);\n"
"		    goto l_%s;\n"
"		  }\n"
"		}\n",
"/* crseg */\n"
"		crseg(%s, SEGLEN%s);\n",
"/* descr */\n"
"		descr(%s, %s, %s);\n",
"/* dlseg */\n"
"		dlseg();\n",
"/* dvi */\n"
"		{ int pop1= pop();\n"
"		  push(pop() / pop1);\n"
"		}\n",
"/* eq */\n"
"		push(pop() == pop());\n",
"/* eqn */\n"
"		push(eqn(pop(), %s, %s));\n",
"/* ge */\n"
"		push(pop() <= pop());\n",
"/* gt */\n"
"		push(pop() < pop());\n",
"/* halt */\n"
"		return 0;\n",
"/* jiff */\n"
"		if (!pop())\n"
"		  goto l_%s;\n",
"/* jift */\n"
"		if (pop())\n"
"		  goto l_%s;\n",
"/* jump */\n"
"		goto l_%s;\n",
"/* ldcon */\n"
"		push(%s); \n",
"/* ldind */\n"
"		{ int addr= pop();\n"
"		  push(addr);\n"
"		  push(getmema(addr));\n"
"		}\n",
"/* ldnvar */\n"
"		{ int i, n= pop(), sn= %s, dpl= %s;\n"
"		  if (n == 0) {\n"
"		    n= getmemr(sn, dpl+2);\n"
"		    dpl= getmemr(sn, dpl+1);\n"
"		  }\n"
"		  for (i= 0; i < n; i++)\n"
"		    push(getmemr(sn, dpl+i));\n"
"		}\n",
"/* ldvar */\n"
"		push(getmemr(%s, %s));\n",
"/* ldxvar */\n"
"		{ int sn= %s;\n"
"		  push(getmemr(sn, ixdpl(sn, %s)));\n"
"		}\n",
"/* le */\n"
"		push(pop() >= pop());\n",
"/* lt */\n"
"		push(pop() > pop());\n",
"/* mdl */\n"
"		{ int pop1= pop();\n"
"		  push(pop() %% pop1);\n"
"		}\n",
"/* mul */\n"
"		push(pop() * pop());\n",
"/* ne */\n"
"		push(pop() != pop());\n",
"/* neg */\n"
"		push(-pop());\n",
"/* nen */\n"
"		push(!eqn(pop(), %s, %s));\n",
"/* noop */\n",
"/* not */\n"
"		push(pop() == 0);\n",
"/* or */\n"
"		push(pop() | pop());\n",
"/* pop */\n"
"		pop();\n",
"/* popn */\n"
"		{ int n= pop(), sn= %s, dpl= %s;\n"
"		  if (n == 0)\n"
"		    n= getmemr(sn, dpl+2);\n"
"		  while (n--)\n"
"		    pop();\n"
"		}\n",
"/* rdchar */\n"
"		push(rdbool());\n",
"/* rdbool */\n"
"		push(rdchar());\n",
"/* rdint */\n"
"		push(rdint());\n",
"/* rdstring */\n"
"		push(rdstring(STRTABSIZE));\n",
"/* return_ */\n"
"		{ jmp_buf jmpbuf;\n"
"		  creturn_(&jmpbuf);\n"
"		  longjmp(jmpbuf, 1);\n"
"		}\n",
"/* stind */\n"
"		{ int val= pop(), addr= pop();\n"
"		  push(addr);\n"
"		  putmema(val, addr);\n"
"		}\n",
"/* stnvar */\n"
"		{ int n= pop(), sn= %s, dpl= %s;\n"
"		  if (n == 0) {\n"
"		    n= getmemr(sn, dpl+2);\n"
"		    dpl= getmemr(sn, dpl+1);\n"
"		  }\n"
"		  while (--n >= 0)\n"
"		    putmemr(sn, dpl+n, pop());\n"
"		}\n",
"/* stvar */\n"
"		putmemr(%s, %s, pop());\n",
"/* stxvar */\n"
"		{ int sn= %s, dpl= ixdpl(sn, %s);\n"
"		  putmemr(sn, dpl, pop());\n"
"		}\n",
"/* sub */\n"
"		push(-pop() + pop());\n",
"/* swap */\n"
"		swap();\n",
"/* varaddr */\n"
"		push(varaddr(%s, %s));\n",
"/* wrbool */\n"
"		wrbool(push(pop()));\n",
"/* wrchar */\n"
"		wrchar(push(pop()));\n",
"/* wrint */\n"
"		wrint(push(pop()));\n",
"/* wrstring */\n"
"		wrstring(STRTABSIZE, push(pop()));\n",
"/* xvaraddr */\n"
"		{ int sn= %s;\n"
"		  push(varaddr(sn, ixdpl(sn, %s)));\n"
"		}\n",
};

static FILE	*GenFp, *LtFp, *StFp;
static char	LtFname[]= "lentab.h", StFname[]= "strtab.h";

void
startcode(void)
{
	string	filename;
	char	*ext, *basename;

	/* strip leading path */
	if ((basename= strrchr(i_input_name, '/')) != 0)
		basename++;
	else
		basename= i_input_name;

	/* replace or add .c extension */
	if ((ext= strrchr(basename, '.')) != 0)
		sprintf(filename, "%.*s.c", (int)(ext-basename), basename);
	else
		sprintf(filename, "%s.c", basename);

	fprintf(stderr, "- generating     : %s\n", filename);

	if ((GenFp= fopen(filename, "w")) == 0) {
		printf("File '%s' not writeable\n", filename);
		exit(1);
	}

	fputs("#include \"rts.h\"\n", GenFp);
	fprintf(GenFp, "#include \"%s\"\n", LtFname);
	fprintf(GenFp, "#include \"%s\"\n", StFname);
	fputs("int\n", GenFp);
	fputs("main(void)\n", GenFp);
	fputs("{\n", GenFp);
}

void
emitcode(operation opc, string arg1, string arg2, string arg3)
{
	fprintf(GenFp, codetable[opc], arg1, arg2, arg3);
}

void
finishcode(void)
{
	fputs("}\n", GenFp);
	fclose(GenFp);
}

void
startlentab(void)
{
	if ((LtFp= fopen(LtFname, "w")) == 0) {
		perror(LtFname);
		exit(1);
	}
}

void
emitlen(string index, string len)
{
	fprintf(LtFp, "#define SEGLEN%s %s\n", index, len);
}

void
finishlentab(void)
{
	fclose(LtFp);
}

void
startstrtab(void)
{
	if ((StFp= fopen(StFname, "w")) == 0) {
		perror(StFname);
		exit(1);
	}
	fputs("char *StringTab[]= {\n", StFp);
}

void
emitstr(string index, string str)
{
	fprintf(StFp, "\t%s,\n", str);
}

void
finishstrtab(void)
{
	fputs("\t0\n};\n", StFp);
	fputs("#define STRTABSIZE (sizeof StringTab/sizeof StringTab[0])-1\n"
	, StFp);
	fclose(StFp);
}

#ifdef TEST
char	i_input_name[]= "test.c";

int
main(void)
{
	startcode();
	emitcode(label_nr, "1", NULL, NULL);
	emitcode(abs_opc, NULL, NULL, NULL);
	emitcode(add_opc, NULL, NULL, NULL);
	emitcode(and_opc, NULL, NULL, NULL);
	emitcode(call_opc, "1", NULL, NULL);
	emitcode(crseg_opc, "1", "1", NULL);
	emitcode(descr_opc, "1", "0", "3");
	emitcode(dlseg_opc, NULL, NULL, NULL);
	emitcode(dvi_opc, NULL, NULL, NULL);
	emitcode(eq_opc, NULL, NULL, NULL);
	emitcode(eqn_opc, "1", "0", NULL);
	emitcode(ge_opc, NULL, NULL, NULL);
	emitcode(gt_opc, NULL, NULL, NULL);
	emitcode(jiff_opc, "1", NULL, NULL);
	emitcode(jift_opc, "1", NULL, NULL);
	emitcode(jump_opc, "1", NULL, NULL);
	emitcode(ldcon_opc, "1", NULL, NULL);
	emitcode(ldind_opc, NULL, NULL, NULL);
	emitcode(ldnvar_opc, "1", "0", NULL);
	emitcode(ldvar_opc, "1", "0", NULL);
	emitcode(ldxvar_opc, "1", "0", "1");
	emitcode(le_opc, NULL, NULL, NULL);
	emitcode(lt_opc, NULL, NULL, NULL);
	emitcode(mdl_opc, NULL, NULL, NULL);
	emitcode(mul_opc, NULL, NULL, NULL);
	emitcode(ne_opc, NULL, NULL, NULL);
	emitcode(neg_opc, NULL, NULL, NULL);
	emitcode(nen_opc, "1", "0", NULL);
	emitcode(no_opc, NULL, NULL, NULL);
	emitcode(not_opc, NULL, NULL, NULL);
	emitcode(or_opc, NULL, NULL, NULL);
	emitcode(pop_opc, NULL, NULL, NULL);
	emitcode(popn_opc, "1", "0", NULL);
	emitcode(rdbool_opc, NULL, NULL, NULL);
	emitcode(rdchar_opc, NULL, NULL, NULL);
	emitcode(rdint_opc, NULL, NULL, NULL);
	emitcode(rdstring_opc, NULL, NULL, NULL);
	emitcode(return_opc, NULL, NULL, NULL);
	emitcode(stind_opc, NULL, NULL, NULL);
	emitcode(stnvar_opc, "1", "0", NULL);
	emitcode(stvar_opc, "1", "0", NULL);
	emitcode(stxvar_opc, "1", "0", "1");
	emitcode(sub_opc, NULL, NULL, NULL);
	emitcode(swap_opc, NULL, NULL, NULL);
	emitcode(varaddr_opc, "1", "0", NULL);
	emitcode(wrbool_opc, NULL, NULL, NULL);
	emitcode(wrchar_opc, NULL, NULL, NULL);
	emitcode(wrint_opc, NULL, NULL, NULL);
	emitcode(wrstring_opc, NULL, NULL, NULL);
	emitcode(xvaraddr_opc, "1", "0", "1");
	emitcode(halt_opc, NULL, NULL, NULL);
	finishcode();
	startlentab();
	emitlen("1", "2");
	finishlentab();
	startstrtab();
	emitstr(NULL, "\"This is a string\"");
	finishstrtab();
	return 0;
}
#endif
