#include <stdio.h>
#include "vimcode.h"
#include "v2j.h"

#define MAXSTRINGS	250	/* maximum number of strings */
#define MAXSEGMENTS	250	/* maximum number of segments */
#define NLOCALS		10	/* maximum number of local variables in JVM */
#define STACKSIZE	250	/* maximum stack size */

#define SLADEHOME	"SLADE"	/* Slade's home environment variable */
#define EXTMAC_J	"extmac.j"	/* external macro filename */
#define BUFLEN		120			/* maximum line/filename length of: extmac.j */

static FILE		*GenFp;
static char		*ClassName, *StringTable[MAXSTRINGS];
static int		NrStrings, NrSegments, SegmentLength[MAXSEGMENTS];

static char *codetable[]= {
"		goto L%s\n" 
"	P%s:\n" 
"		astore_1\n"
"		aload_0\n"
"		iload_1\n"
"		invokevirtual rts/pushReturn(I)V\n"
"	L%s:\n",
"; abs_\n"
"		ifge abs%d\n"
"		ineg\n"
"	abs%d:\n",
"; add\n"
"		iadd\n",
"; and\n"
"		iand\n",
"; call label\n"
"		jsr P%s\n",
"; crseg sn index\n"
"		aload_0\n"
"		sipush %s\n"
"		getstatic %s/SegmentLength [I\n"
"		sipush %s\n"
"		iaload\n"
"		invokevirtual rts/crseg(II)V\n",
"; descr sn dpl dim\n"
"		sipush %s\n"
"		sipush %s\n"
"		sipush %s\n"
"		jsr descr\n",
"; dlseg\n"
"		aload_0\n"
"		invokevirtual rts/dlseg()V\n",
"; dvi\n"
"		idiv\n",
"; eq\n"
"		if_icmpeq eq%d\n"
"		iconst_0\n"
"		goto eq%d\n"
"	eq%d:\n"
"		iconst_1\n"
"	eq%d:\n",
"; eqn sn dpl\n"
"		sipush %s\n"
"		sipush %s\n"
"		jsr eqn\n",
"; ge\n"
"		if_icmpge ge%d\n"
"		iconst_0\n"
"		goto ge%d\n"
"	ge%d:\n"
"		iconst_1\n"
"	ge%d:\n",
"; gt\n"
"		if_icmpgt gt%d\n"
"		iconst_0\n"
"		goto gt%d\n"
"	gt%d:\n"
"		iconst_1\n"
"	gt%d:\n",
"; halt\n"
"		iconst_0\n"
"		return\n",
"; jiff label\n"
"		ifeq L%s\n",
"; jift label\n"
"		ifne L%s\n",
"; jump label\n"
"		goto L%s\n",
"; ldcon value\n"
"		sipush %s\n",
"; ldind\n"
"		istore_1 ; pop address\n"
"		iload_1 ; push address\n"
"		aload_0\n"
"		iload_1\n"
"		invokevirtual rts/getmema(I)I ; push Data[address]\n",
"; ldnvar sn dpl\n"
"		sipush %s\n"
"		sipush %s\n"
"		jsr ldnvar\n",
"; ldvar sn dpl\n"
"		aload_0\n"
"		sipush %s\n"
"		sipush %s\n"
"		invokevirtual rts/getmemr(II)I ; push Data[CSG[sn]+dpl]\n",
"; ldxvar sn dpl\n"
"		sipush %s\n"
"		sipush %s\n"
"		jsr ixdpl ; compute xdpl\n"
"		istore_1\n"
"		aload_0\n"
"		sipush %s\n"
"		iload_1\n"
"		invokevirtual rts/getmemr(II)I ; push Data[CSG[sn]+xdpl]\n",
"; le\n"
"		if_icmple le%d\n"
"		iconst_0\n"
"		goto le%d\n"
"	le%d:\n"
"		iconst_1\n"
"	le%d:\n",
"; lt\n"
"		if_icmplt lt%d\n"
"		iconst_0\n"
"		goto lt%d\n"
"	lt%d:\n"
"		iconst_1\n"
"	lt%d:\n",
"; mdl\n"
"		irem\n",
"; mul\n"
"		imul\n",
"; ne\n"
"		if_icmpne ne%d\n"
"		iconst_0\n"
"		goto ne%d\n"
"	ne%d:\n"
"		iconst_1\n"
"	ne%d:\n",
"; neg\n"
"		ineg\n",
"; nen sn dpl\n"
"		sipush %s\n"
"		sipush %s\n"
"		jsr eqn\n"
"		ifeq nen%d\n"
"		iconst_0\n"
"		goto nen%d\n"
"	nen%d:\n"
"		iconst_1\n"
"	nen%d:\n",
"; noop\n"
"		nop\n",
"; not\n"
"		ifeq not%d\n"
"		iconst_0\n"
"		goto not%d\n"
"	not%d:\n"
"		iconst_1\n"
"	not%d:\n",
"; or\n"
"		ior\n",
"; pop\n"
"		pop\n",
"; popn sn dpl\n"
"		sipush %s\n"
"		sipush %s\n"
"		jsr popn\n",
"; rdbool\n"
"		getstatic rts/stdin Ljava/io/BufferedReader;\n"
"		invokevirtual java/io/BufferedReader/readLine()Ljava/lang/String;\n"
"		ldc \"true\"\n"
"		invokevirtual java/lang/String/equalsIgnoreCase(Ljava/lang/String;)Z\n",
"; rdchar\n"
"		getstatic rts/stdin Ljava/io/BufferedReader;\n"
"		invokevirtual java/io/BufferedReader/readLine()Ljava/lang/String;\n"
"		iconst_0\n"
"		invokevirtual java/lang/String/charAt(I)C\n",
"; rdint\n"
"		getstatic rts/stdin Ljava/io/BufferedReader;\n"
"		invokevirtual java/io/BufferedReader/readLine()Ljava/lang/String;\n"
"		invokestatic java/lang/Integer/parseInt(Ljava/lang/String;)I\n",
"; rdstring\n"
"		getstatic %s/StringTable [Ljava/lang/String; \n"
"		getstatic %s/NrStrings I\n"
"		getstatic rts/stdin Ljava/io/BufferedReader;\n"
"		invokevirtual java/io/BufferedReader/readLine()Ljava/lang/String;\n"
"		aastore\n"
"		getstatic %s/NrStrings I\n"
"		dup\n"
"		iconst_1\n"
"		iadd\n"
"		putstatic %s/NrStrings I\n",
"; return_\n"
"		aload_0\n"
"		invokevirtual rts/popReturn()I\n"
"		astore_1\n"
"		ret 1\n",
"; stind\n"
"		istore_1 ; pop value\n"
"		dup ; dup address\n"
"		istore_2 ; pop address\n"
"		aload_0\n"
"		iload_1\n"
"		iload_2\n"
"		invokevirtual rts/putmema(II)V ; Data[adress]= value;\n",
"; stnvar sn dpl\n"
"		sipush %s\n"
"		sipush %s\n"
"		jsr stnvar\n",
"; stvar sn dpl\n"
"		aload_0\n"
"		swap\n"
"		sipush %s\n"
"		sipush %s\n"
"		invokevirtual rts/putmemr(III)V ; Data[CSG[sn]+dpl]= value;\n",
"; stxvar sn dpl\n"
"		sipush %s\n"
"		sipush %s\n"
"		jsr ixdpl ; compute xdpl\n"
"		istore_1 ; pop xdpl\n"
"		istore_2 ; pop value\n"
"		aload_0\n"
"		iload_2\n"
"		sipush %s\n"
"		iload_1\n"
"		invokevirtual rts/putmemr(III)V ; Data[CSG[sn]+xdpl]= value;\n",
"; sub\n"
"		isub\n",
"; swap\n"
"		swap\n",
"; varaddr sn dpl\n"
"		aload_0\n"
"		sipush %s\n"
"		sipush %s\n"
"		invokevirtual rts/varaddr(II)I ; push CSG[sn]+dpl\n",
"; wrbool\n"
"		dup\n"
"		getstatic rts/stdout Ljava/io/PrintStream;\n"
"		swap\n"
"		invokevirtual java/io/PrintStream/println(Z)V\n",
"; wrchar\n"
"		dup\n"
"		getstatic rts/stdout Ljava/io/PrintStream;\n"
"		swap\n"
"		invokevirtual java/io/PrintStream/println(C)V\n",
"; wrint\n"
"		dup\n"
"		getstatic rts/stdout Ljava/io/PrintStream;\n"
"		swap\n"
"		invokevirtual java/io/PrintStream/println(I)V\n",
"; wrstring\n"
"		dup\n"
"		getstatic %s/StringTable [Ljava/lang/String;\n"
"		swap\n"
"		aaload\n"
"		getstatic rts/stdout Ljava/io/PrintStream;\n"
"		swap\n"
"		invokevirtual java/io/PrintStream/println(Ljava/lang/String;)V\n",
"; xvaraddr sn dpl\n"
"		sipush %s\n"
"		sipush %s\n"
"		jsr ixdpl ; compute xdpl\n"
"		istore_1 ; pop xdpl\n"
"		aload_0\n"
"		sipush %s\n"
"		iload_1\n"
"		invokevirtual rts/varaddr(II)I ; push CSG[sn]+xdpl\n",
};

void
startcode(void)
{
	string	filename;
	char	*ext;

	/* strip leading path */
	if ((ClassName= strrchr(i_input_name, '/')) != 0)
		ClassName++;
	else
		ClassName= i_input_name;

	/* replace or add .j extension */
	if ((ext= strrchr(ClassName, '.')) != 0) {
		*ext= 0;
		strcpy(filename, ClassName);
		strcat(filename, ".j");
	} else
		sprintf(filename, "%s.j", ClassName);

	fprintf(stderr, "- generating     : %s\n", filename);

	if ((GenFp= fopen(filename, "w")) == 0) {
		printf("File '%s' not writeable\n", filename);
		exit(1);
	}

	fputs(";\n; Output generated by SLADE's v2j translator\n", GenFp);
	fputs("; mailto:groen@cs.utwente.nl\n;\n", GenFp);

	fprintf(GenFp, ".class public synchronized %s\n", ClassName);
	fputs(".super java/lang/Object\n\n", GenFp);

	fputs(".field static NrSegments I\n", GenFp);
	fputs(".field static SegmentLength [I\n\n", GenFp);
	fputs(".field static NrStrings I\n", GenFp);
	fputs(".field static StringTable [Ljava/lang/String;\n\n", GenFp);

	fputs(".method public static main([Ljava/lang/String;)V\n", GenFp);
	fputs("\t.throws java/io/IOException\n", GenFp);
	fprintf(GenFp, "\t.limit stack %d\n", STACKSIZE);
	fprintf(GenFp, "\t.limit locals %d\n", NLOCALS+1);

	fputs("\t; initialize run time system and store it in local 0\n", GenFp);
	fputs("\tnew rts\n", GenFp);
	fputs("\tdup\n", GenFp);
	fputs("\tinvokenonvirtual rts/<init>()V\n", GenFp);
	fputs("\tastore_0\n", GenFp);
}

void
emitcode(opcode opc, string arg1, string arg2, string arg3)
{
	static int	labnr= 1;

	switch (opc) {
	case label_nr:
		fprintf(GenFp, codetable[opc], arg1, arg1, arg1);
		break;

	case abs_opc:
		fprintf(GenFp, codetable[opc], labnr, labnr);
		labnr++;
		break;

	case crseg_opc:
		fprintf(GenFp, codetable[opc], arg1, ClassName, arg2);
		break;

	case eq_opc: case ne_opc: case ge_opc: case le_opc:
	case gt_opc: case lt_opc: case not_opc:
		fprintf(GenFp, codetable[opc], labnr, labnr+1, labnr, labnr+1);
		labnr += 2;
		break;

	case nen_opc:
		fprintf(GenFp, codetable[opc], arg1, arg2
		, labnr, labnr+1, labnr, labnr+1);
		labnr += 2;
		break;

	case ldxvar_opc:
	case stxvar_opc:
	case xvaraddr_opc:
		fprintf(GenFp, codetable[opc], arg1, arg2, arg1);
		break;

	case rdstring_opc:
		fprintf(GenFp, codetable[opc], ClassName, ClassName, ClassName
		, ClassName);
		break;

	case wrstring_opc:
		fprintf(GenFp, codetable[opc], ClassName, arg1, arg2, arg3);
		break;

	default:
		fprintf(GenFp, codetable[opc], arg1, arg2, arg3);
	}
}

void
finishcode(void)
{
	char	buf[BUFLEN+1], *dir;
	FILE	*fp;

	if ((dir= getenv(SLADEHOME)) == 0)
		dir= ".";

	strcpy(buf, EXTMAC_J);
	if ((fp= fopen(buf, "rt")) == 0) {
		sprintf(buf, "%s/include/%s", dir, EXTMAC_J);
		if ((fp= fopen(buf, "rt")) == 0)
			fprintf(stderr, "Could not include '%s'\n", buf);
	}

	if (fp != 0) {
		while (fgets(buf, BUFLEN, fp))
			fputs(buf, GenFp);
		fclose(fp);
	}

	fputs(".end method\n\n", GenFp);
}

void
startlentab(void)
{
	NrSegments= 0;
	fputs(".method static <clinit>()V\n", GenFp);
	fputs("\t.limit stack 5\n", GenFp);
	fputs("\t.limit locals 1\n", GenFp);

}

void
emitlen(string index, string len)
{
	if (NrSegments < MAXSEGMENTS)
		SegmentLength[NrSegments++]= atoi(len);
}

void
finishlentab(void)
{
	int		i;

	fprintf(GenFp, "\tsipush %d\n", NrSegments);
	fprintf(GenFp, "\tputstatic %s/NrSegments I\n", ClassName);

	fputs("\n\t; initialize length table\n", GenFp);
	/* Note: table element 0 is not used, numbering starts at 1 */
	fprintf(GenFp, "\tsipush %d\n", NrSegments+1);
	fputs("\tnewarray int\n", GenFp);
	for (i= 0; i < NrSegments; i++) {
		fputs("\tdup\n", GenFp);
		fprintf(GenFp, "\tsipush %d\n", i+1);
		fprintf(GenFp, "\tsipush %d\n", SegmentLength[i]);
		fputs("\tiastore\n", GenFp);
	}
	fprintf(GenFp, "\tputstatic %s/SegmentLength [I\n", ClassName);
}

void
startstrtab(void)
{
	NrStrings= 0;
}

void
emitstr(string index, string str)
{
	if (NrStrings < MAXSTRINGS)
		StringTable[NrStrings++]= strdup(str);
}

void
finishstrtab(void)
{
	int		i;

	fprintf(GenFp, "\tsipush %d\n", NrStrings);
	fprintf(GenFp, "\tputstatic %s/NrStrings I\n", ClassName);

	fputs("\n\t; initialize string table\n", GenFp);
	/* Note: table element 0 is not used, numbering starts at 1 */
	fprintf(GenFp, "\tsipush %d\n", MAXSTRINGS+1);
	fputs("\tanewarray java/lang/String\n", GenFp);
	for (i= 0; i < NrStrings; i++) {
		fputs("\tdup\n", GenFp);
		fprintf(GenFp, "\tsipush %d\n", i+1);
		fprintf(GenFp, "\tldc %s\n", StringTable[i]);
		free(StringTable[i]);
		fputs("\taastore\n", GenFp);
	}
	fprintf(GenFp, "\tputstatic %s/StringTable [Ljava/lang/String;\n", ClassName);

	fputs("\treturn\n", GenFp);
	fputs(".end method\n\n", GenFp);

	fputs(".method public <init>()V\n", GenFp);
	fputs("\t.limit stack 1\n", GenFp);
	fputs("\t.limit locals 1\n", GenFp);
	fputs("\taload_0\n", GenFp);
	fputs("\tinvokespecial java/lang/Object/<init>()V\n", GenFp);
	fputs("\treturn\n", GenFp);
	fputs(".end method\n", GenFp);
	fclose(GenFp);
}

#ifdef TEST
char	i_input_name[]= "test.c";

int
main(void)
{
	startcode();
	emitcode(label_nr, "1", NULL, NULL);
	emitcode(abs_opc, NULL, NULL, NULL);
	emitcode(add_opc, NULL, NULL, NULL);
	emitcode(and_opc, NULL, NULL, NULL);
	emitcode(call_opc, "1", NULL, NULL);
	emitcode(crseg_opc, "1", "1", NULL);
	emitcode(descr_opc, "1", "0", "3");
	emitcode(dlseg_opc, NULL, NULL, NULL);
	emitcode(dvi_opc, NULL, NULL, NULL);
	emitcode(eq_opc, NULL, NULL, NULL);
	emitcode(eqn_opc, "1", "0", NULL);
	emitcode(ge_opc, NULL, NULL, NULL);
	emitcode(gt_opc, NULL, NULL, NULL);
	emitcode(jiff_opc, "1", NULL, NULL);
	emitcode(jift_opc, "1", NULL, NULL);
	emitcode(jump_opc, "1", NULL, NULL);
	emitcode(ldcon_opc, "1", NULL, NULL);
	emitcode(ldind_opc, NULL, NULL, NULL);
	emitcode(ldnvar_opc, "1", "0", NULL);
	emitcode(ldvar_opc, "1", "0", NULL);
	emitcode(ldxvar_opc, "1", "0", "1");
	emitcode(le_opc, NULL, NULL, NULL);
	emitcode(lt_opc, NULL, NULL, NULL);
	emitcode(mdl_opc, NULL, NULL, NULL);
	emitcode(mul_opc, NULL, NULL, NULL);
	emitcode(ne_opc, NULL, NULL, NULL);
	emitcode(neg_opc, NULL, NULL, NULL);
	emitcode(nen_opc, "1", "0", NULL);
	emitcode(no_opc, NULL, NULL, NULL);
	emitcode(not_opc, NULL, NULL, NULL);
	emitcode(or_opc, NULL, NULL, NULL);
	emitcode(pop_opc, NULL, NULL, NULL);
	emitcode(popn_opc, "1", "0", NULL);
	emitcode(rdbool_opc, NULL, NULL, NULL);
	emitcode(rdchar_opc, NULL, NULL, NULL);
	emitcode(rdint_opc, NULL, NULL, NULL);
	emitcode(rdstring_opc, NULL, NULL, NULL);
	emitcode(return_opc, NULL, NULL, NULL);
	emitcode(stind_opc, NULL, NULL, NULL);
	emitcode(stnvar_opc, "1", "0", NULL);
	emitcode(stvar_opc, "1", "0", NULL);
	emitcode(stxvar_opc, "1", "0", "1");
	emitcode(sub_opc, NULL, NULL, NULL);
	emitcode(swap_opc, NULL, NULL, NULL);
	emitcode(varaddr_opc, "1", "0", NULL);
	emitcode(wrbool_opc, NULL, NULL, NULL);
	emitcode(wrchar_opc, NULL, NULL, NULL);
	emitcode(wrint_opc, NULL, NULL, NULL);
	emitcode(wrstring_opc, NULL, NULL, NULL);
	emitcode(xvaraddr_opc, "1", "0", "1");
	emitcode(halt_opc, NULL, NULL, NULL);
	finishcode();
	startlentab();
	emitlen("1", "2");
	finishlentab();
	startstrtab();
	emitstr(NULL, "\"This is a string\"");
	finishstrtab();
	return 0;
}
#endif

