#include <stdio.h>
#include "vimcode.h"
#include "v2s.h"

static char *codetable[]= {
	"L%s:\n",
"# abs_\n"
"		call	_abs\n"
"		addl	$4,%%esp\n",
"# add\n"
"		popl	%%eax\n"
"		addl	%%eax, (%%esp)\n",
"# and\n"
"		popl	%%eax\n"
"		andl	%%eax, (%%esp)\n",
"# call\n"
"		xcall	R%d, L%s\n"
"R%d:\n"
"		.long	.+4\n",
"# crseg\n"
"		pushl	$SEGLEN%s\n"
"		pushl	$%s\n"
"		call	_crseg\n"
"		addl	$8, %%esp\n",
"# descr\n"
"		descr	$%s, $%s, $%s\n",
"# dlseg\n"
"		call	_dlseg\n",
"# dvi\n"
"		popl	%%ebx\n"
"		movl	(%%esp), %%eax\n"
"		cltd\n"
"		idivl	%%ebx\n"
"		movl	%%eax, (%%esp)\n",
"# eq\n"
"		popl	%%eax\n"
"		cmpl	%%eax, (%%esp)\n"
"		sete	%%dl\n"
"		movzbl	%%dl, %%eax\n"
"		movl	%%eax, (%%esp)\n",
"# eqn\n"
"		popl	%%eax\n"
"		eqn	%%eax, $%s, $%s\n"
"		pushl	%%eax\n",
"# ge\n"
"		popl	%%eax\n"
"		cmpl	%%eax, (%%esp)\n"
"		setge	%%dl\n"
"		movzbl	%%dl, %%eax\n"
"		movl	%%eax, (%%esp)\n",
"# gt\n"
"		popl	%%eax\n"
"		cmpl	%%eax, (%%esp)\n"
"		setg	%%dl\n"
"		movzbl	%%dl, %%eax\n"
"		movl	%%eax, (%%esp)\n",
"# halt\n"
"		push	$0\n"
"		call	_exit\n",
"# jiff\n"
"		popl	%%eax\n"
"		testl	%%eax, %%eax\n"
"		je	L%s\n",
"# jift\n"
"		popl	%%eax\n"
"		testl	%%eax, %%eax\n"
"		jne	L%s\n",
"# jump\n"
"		jmp	L%s\n",
"# ldcon\n"
"		pushl	$%s\n",
"# ldind\n"
"		pushl	(%%esp)\n"
"		call	_getmema\n"
"		addl	$4, %%esp\n"
"		pushl	%%eax\n",
"# ldnvar\n"
"		ldnvar	$%s, $%s\n",
"# ldvar\n"
"		pushl	$%s\n"
"		pushl	$%s\n"
"		call	_getmemr\n"
"		addl	$8, %%esp\n"
"		pushl	%%eax\n",
"# ldxvar\n"
"		ixdpl	$%s, $%s\n"
"		pushl	$%s\n"
"		call	_getmemr\n"
"		addl	$8, %%esp\n"
"		pushl	%%eax\n",
"# le\n"
"		popl	%%eax\n"
"		cmpl	%%eax, (%%esp)\n"
"		setle	%%dl\n"
"		movzbl	%%dl, %%eax\n"
"		movl	%%eax, (%%esp)\n",
"# lt\n"
"		popl	%%eax\n"
"		cmpl	%%eax, (%%esp)\n"
"		setl	%%dl\n"
"		movzbl	%%dl, %%eax\n"
"		movl	%%eax, (%%esp)\n",
"# mdl\n"
"		popl	%%ebx\n"
"		movl	(%%esp), %%eax\n"
"		cltd\n"
"		idivl	%%ebx\n"
"		movl	%%edx, (%%esp)\n",
"# mul\n"
"		popl	%%eax\n"
"		imull	(%%esp)\n"
"		movl	%%eax, (%%esp)\n",
"# ne\n"
"		popl	%%eax\n"
"		cmpl	%%eax, (%%esp)\n"
"		setne	%%dl\n"
"		movzbl	%%dl, %%eax\n"
"		movl	%%eax, (%%esp)\n",
"# neg\n"
"		negl	(%%esp)\n",
"# nen\n"
"		popl	%%eax\n"
"		eqn	%%eax, $%s, $%s\n"
"		cmpl	$0, %%eax\n"
"		sete	%%al\n"
"		movzbl	%%al, %%eax\n"
"		pushl	%%eax\n",
"# noop\n"
"		nop\n",
"# not\n"
"		popl	%%eax\n"
"		cmpl	$0, %%eax\n"
"		sete	%%al\n"
"		movzbl	%%al, %%eax\n"
"		pushl	%%eax\n",
"# or\n"
"		popl	%%eax\n"
"		orl	%%eax, (%%esp)\n",
"# pop\n"
"		popl	%%eax\n",
"# popn\n"
"		popn	$%s, $%s\n",
"# rdbool\n"
"		call	_rdbool	 \n"
"		pushl	%%eax\n",
"# rdchar\n"
"		call	_rdchar	 \n"
"		pushl	%%eax\n",
"# rdint\n"
"		call	_rdint	 \n"
"		pushl	%%eax\n",
"# rdstring\n"
"		pushl	$STRTABSIZE\n"
"		call	_rdstring\n"
"		addl	$4, %%esp\n"
"		pushl	%%eax\n",
"# return_\n"
"		call	_asreturn_\n"
"		jmp	%%eax\n",
"# stind\n"
"		call	_putmema\n"
"		addl	$4, %%esp\n",
"# stnvar\n"
"		stnvar	$%s, $%s\n",
"# stvar\n"
"		pushl	$%s\n"
"		pushl	$%s\n"
"		call	_putmemr\n"
"		addl	$12, %%esp\n",
"# stxvar\n"
"		ixdpl	$%s, $%s\n"
"		pushl	$%s\n"
"		call	_putmemr\n"
"		addl	$12, %%esp\n",
"# sub\n"
"		popl	%%eax\n"
"		negl	%%eax\n"
"		addl	%%eax, (%%esp)\n",
"# swap\n"
"		popl	%%eax\n"
"		popl	%%ebx\n"
"		pushl	%%eax\n"
"		pushl	%%ebx\n",
"# varaddr\n"
"		pushl	$%s\n"
"		pushl	$%s\n"
"		call	_varaddr\n"
"		addl	$8, %%esp\n"
"		pushl	%%eax\n",
"# wrbool\n"
"		call	_wrbool\n",
"# wrchar\n"
"		call	_wrchar\n",
"# wrint\n"
"		call	_wrint\n",
"# wrstring\n"
"		pushl	$STRTABSIZE\n"
"		call	_wrstring\n"
"		addl	$4, %%esp\n",
"# xvaraddr\n"
"		ixdpl	$%s, $%s\n"
"		pushl	$%s\n"
"		call	_varaddr\n"
"		addl	$8, %%esp\n"
"		pushl	%%eax\n",
};

static FILE			*GenFp, *LtFp, *StFp;
static char			LtFname[]= "lentab.s", StFname[]= "strtab.s";

#define MAX_STRINGS	250	/* maximum number of strings */

static integer		StringTabSize;
static char			*StringTab[MAX_STRINGS];

void
startcode(void)
{
	string	filename;
	char	*ext, *basename;

	/* strip leading path */
	if ((basename= strrchr(i_input_name, '/')) != 0)
		basename++;
	else
		basename= i_input_name;

	/* replace or add .s extension */
	if ((ext= strrchr(basename, '.')) != 0)
		sprintf(filename, "%.*s.s", (int)(ext-basename), basename);
	else
		sprintf(filename, "%s.s", basename);

	fprintf(stderr, "- generating     : %s\n", filename);

	if ((GenFp= fopen(filename, "w")) == 0) {
		printf("File '%s' not writeable\n", filename);
		exit(1);
	}

	fprintf(GenFp, ".include \"extmac.s\"\t# include array/call macros\n");
	fprintf(GenFp, ".include \"%s\"\t# include segment length macros\n"
	, LtFname);
	fprintf(GenFp, ".include \"%s\"\t# include string table\n", StFname);

#ifdef linux
	fputs("\n.global main\t\t\t# export main routine\n", GenFp);
	fputs("main:\t\t\t\t# 80386 assembler of vim code\n", GenFp);
#else
	fputs("\n.global _main\t\t\t# export main routine\n", GenFp);
	fputs("_main:\t\t\t\t# 80386 assembler of vim code\n", GenFp);
#endif
}

void
emitcode(opcode opc, string arg1, string arg2, string arg3)
{
	static int	returnlabel= 1;

	switch (opc) {
	case call_opc:
		fprintf(GenFp, codetable[opc], returnlabel, arg1, returnlabel);
		returnlabel++;
		break;
	case ldxvar_opc:
	case stxvar_opc:
	case xvaraddr_opc:
		fprintf(GenFp, codetable[opc], arg1, arg2, arg1);
		break;
	case crseg_opc:
	case ldvar_opc:
	case stvar_opc:
	case varaddr_opc:
		fprintf(GenFp, codetable[opc], arg2, arg1, arg3);
		break;
	default:
		fprintf(GenFp, codetable[opc], arg1, arg2, arg3);
	}
}

void
finishcode(void)
{
	fclose(GenFp);
}

void
startlentab(void)
{
	if ((LtFp= fopen(LtFname, "w")) == 0) {
		perror(LtFname);
		exit(1);
	}
}

void
emitlen(string index, string value)
{
	fprintf(LtFp, ".equ SEGLEN%s, %s\n", index, value);
}

void
finishlentab(void)
{
	fclose(LtFp);
}

void
startstrtab(void)
{
	if ((StFp= fopen(StFname, "w")) == 0) {
		perror(StFname);
		exit(1);
	}
	StringTabSize= 0;

#ifdef linux
	fputs(".global StringTab\n", StFp);
#else
	fputs(".global _StringTab\n", StFp);
#endif

	fputs(".data\n", StFp);
	fputs("\t.align 2\n", StFp);

#ifdef linux
	fputs("StringTab:\n", StFp);
#else
	fputs("_StringTab:\n", StFp);
#endif
}

void
emitstr(string index, string str)
{
	if (StringTabSize >= MAX_STRINGS) {
		i_report(i_ESTRTAB, MAX_STRINGS);
		return;
	}
	if ((StringTab[StringTabSize]= strdup(str)) == 0) {
		i_report(i_ENOMEM, __LINE__, __FILE__);
		return;
	}
	fprintf(StFp, "\t.long LC%d\n", StringTabSize++);
}

void
finishstrtab(void)
{
	int	i;

	fputs("\t.long 0\n", StFp);
	fputs(".text\n", StFp);
	for (i= 0; i < StringTabSize; i++) {
		fprintf(StFp, "LC%d:\n", i);
		fprintf(StFp, "\t.asciz %s\n", StringTab[i]);
	}
	fputs("\t.align 2\n", StFp);
	fprintf(StFp, ".equ STRTABSIZE, %d\n", StringTabSize);
	fclose(StFp);
}

#ifdef TEST
char	i_input_name[]= "test.s";

int
main(void)
{
	startcode();
	emitcode(label_nr, "1", NULL, NULL);
	emitcode(abs_opc, NULL, NULL, NULL);
	emitcode(add_opc, NULL, NULL, NULL);
	emitcode(and_opc, NULL, NULL, NULL);
	emitcode(call_opc, "1", NULL, NULL);
	emitcode(crseg_opc, "1", "1", NULL);
	emitcode(descr_opc, "1", "0", "3");
	emitcode(dlseg_opc, NULL, NULL, NULL);
	emitcode(dvi_opc, NULL, NULL, NULL);
	emitcode(eq_opc, NULL, NULL, NULL);
	emitcode(eqn_opc, "1", "0", NULL);
	emitcode(ge_opc, NULL, NULL, NULL);
	emitcode(gt_opc, NULL, NULL, NULL);
	emitcode(jiff_opc, "1", NULL, NULL);
	emitcode(jift_opc, "1", NULL, NULL);
	emitcode(jump_opc, "1", NULL, NULL);
	emitcode(ldcon_opc, "1", NULL, NULL);
	emitcode(ldind_opc, NULL, NULL, NULL);
	emitcode(ldnvar_opc, "1", "0", NULL);
	emitcode(ldvar_opc, "1", "0", NULL);
	emitcode(ldxvar_opc, "1", "0", "1");
	emitcode(le_opc, NULL, NULL, NULL);
	emitcode(lt_opc, NULL, NULL, NULL);
	emitcode(mdl_opc, NULL, NULL, NULL);
	emitcode(mul_opc, NULL, NULL, NULL);
	emitcode(ne_opc, NULL, NULL, NULL);
	emitcode(neg_opc, NULL, NULL, NULL);
	emitcode(nen_opc, "1", "0", NULL);
	emitcode(no_opc, NULL, NULL, NULL);
	emitcode(not_opc, NULL, NULL, NULL);
	emitcode(or_opc, NULL, NULL, NULL);
	emitcode(pop_opc, NULL, NULL, NULL);
	emitcode(popn_opc, "1", "0", NULL);
	emitcode(rdbool_opc, NULL, NULL, NULL);
	emitcode(rdchar_opc, NULL, NULL, NULL);
	emitcode(rdint_opc, NULL, NULL, NULL);
	emitcode(rdstring_opc, NULL, NULL, NULL);
	emitcode(return_opc, NULL, NULL, NULL);
	emitcode(stind_opc, NULL, NULL, NULL);
	emitcode(stnvar_opc, "1", "0", NULL);
	emitcode(stvar_opc, "1", "0", NULL);
	emitcode(stxvar_opc, "1", "0", "1");
	emitcode(sub_opc, NULL, NULL, NULL);
	emitcode(swap_opc, NULL, NULL, NULL);
	emitcode(varaddr_opc, "1", "0", NULL);
	emitcode(wrbool_opc, NULL, NULL, NULL);
	emitcode(wrchar_opc, NULL, NULL, NULL);
	emitcode(wrint_opc, NULL, NULL, NULL);
	emitcode(wrstring_opc, NULL, NULL, NULL);
	emitcode(xvaraddr_opc, "1", "0", "1");
	emitcode(halt_opc, NULL, NULL, NULL);
	finishcode();
	startlentab();
	emitlen("1", "2");
	finishlentab();
	startstrtab();
	emitstr(NULL, "\"This is a string\"");
	finishstrtab();
	return 0;
}
#endif

