/*******************************************************************************
* Interface of attribute evaluation functions which is included in a parser
* generated with SLADE
*
* JHG sep97 Copyright (C) 1991-1997 University of Twente
*******************************************************************************/
#ifndef EVALATTR_H
#define EVALATTR_H

#include "cgl.h"

char *i_boolean_text(boolean);
char *i_char_text	(char);
char *i_integer_text(integer);
char *i_real_text	(real);
char *i_string_text	(string);

void assign_bool	(boolean *dest, boolean source);
void assign_char	(char *dest, char source);
void assign_int		(integer *dest, integer source);
void assign_real	(real *dest, real source);
void assign_string	(string *dest, string source);

void clear_bool		(boolean *dest);
void clear_char		(char *dest);
void clear_int		(integer *dest);
void clear_real		(real *dest);
void clear_string	(string *dest);

void read_bool		(boolean *arg, string prompt);
void read_char		(char *arg, string prompt);
void read_int		(integer *arg, string prompt);
void read_real		(real *arg, string prompt);
void read_string	(string *arg, string prompt);

void write_bool		(boolean arg);
void write_char		(char arg);
void write_int		(integer arg);
void write_real		(real arg);
void write_string	(string arg);

#endif /*EVALATTR_H*/
