/*******************************************************************************
* MS Visual C assembler macro definitions for the code generator of SLADE
*
* JHG sep97 SLADE Copyright (C) 1997-1998 University of Twente
*******************************************************************************/
#include "stdlib.h"
#include "rts.h"

static int		_dim, _up, _xdpl, _size, _i, _n, _dpl;

#define xcall(retaddr, label) \
	__asm push	offset retaddr \
	__asm call	ascall \
	__asm add	esp, 4 \
	__asm jmp	label

#define descr(sn, dpl, dim) \
	__asm mov	_size, 1 \
	__asm mov	_dim, dim \
	__asm jmp	$+40 \
	__asm push	_size \
	__asm push	_dim \
	__asm push	dpl \
	__asm push	sn \
	__asm call	putxlowsiz \
	__asm add	esp, 24 \
	__asm mov	_size, eax \
	__asm dec	_dim \
	__asm mov	ebx, _dim \
	__asm test	ebx, ebx \
	__asm jnz	$-43 \
	__asm push	sn \
	__asm call	getseglen \
	__asm add	esp, 4 \
	__asm push	eax \
	__asm push	dpl+1 \
	__asm push	sn \
	__asm call	putmemr \
	__asm add	esp, 12 \
	__asm push	_size \
	__asm push	sn \
	__asm call	incrseglen \
	__asm add	esp, 8 \
	__asm push	dim \
	__asm push	dpl \
	__asm push	sn \
	__asm call	putmemr \
	__asm add	esp, 12

#define eqn(len, sn, dpl) \
	__asm mov	ebx, len \
	__asm test	ebx, ebx \
	__asm jnz	$+20 \
	__asm push	dpl+2 \
	__asm push	sn \
	__asm call	getmemr \
	__asm add	esp, 8 \
	__asm mov	ebx, eax \
	__asm mov	esi, esp \
	__asm imul	ebx, 4 \
	__asm add	esp, ebx \
	__asm mov	edi, esp \
	__asm add	esp, ebx \
	__asm test	ebx, ebx \
	__asm jz	$+30 \
	__asm mov	ecx, [esi] \
	__asm cmp	[edi], ecx \
	__asm jne	$+30 \
	__asm add	edi, 4 \
	__asm add	esi, 4 \
	__asm sub	ebx, 4 \
	__asm jmp	$-27 \
	__asm mov	eax, 1 \
	__asm jmp	$+10 \
	__asm mov	eax, 0

#define ixdpl(sn, dpl) \
	__asm pop	ebx \
	__asm mov	_size, 1 \
	__asm mov	_xdpl, 0 \
	__asm cmp	ebx, 0 \
	__asm jl	$+51 \
	__asm pop	eax \
	__asm pop	edi \
	__asm neg	edi \
	__asm add	eax, edi \
	__asm imul	_size \
	__asm add	_xdpl, eax \
	__asm pop	_size \
	__asm dec	ebx \
	__asm test	ebx, ebx \
	__asm jnz	$-27 \
	__asm add	_xdpl, dpl \
	__asm jmp	$+118 \
	__asm push	dpl \
	__asm push	sn \
	__asm call	getmemr \
	__asm add	esp, 8 \
	__asm mov	ebx, eax \
	__asm jmp	$+73 \
	__asm mov	_dim, ebx \
	__asm push	ebx \
	__asm push	dpl \
	__asm push	sn \
	__asm call	getxlow \
	__asm add	esp, 12 \
	__asm mov	edi, eax \
	__asm pop	eax \
	__asm neg	edi \
	__asm add	eax, edi \
	__asm imul	_size \
	__asm add	_xdpl, eax \
	__asm push	_dim \
	__asm push	dpl \
	__asm push	sn \
	__asm call	getxsize \
	__asm add	esp, 12 \
	__asm mov	_size, eax \
	__asm mov	ebx, _dim \
	__asm dec	ebx \
	__asm test	ebx, ebx \
	__asm jnz	$-70 \
	__asm push	dpl+1 \
	__asm push	sn \
	__asm call	getmemr \
	__asm add	esp, 8 \
	__asm add	_xdpl, eax \
	__asm push	_xdpl

#define ldnvar(sn, dpl) \
	__asm mov	_dpl, dpl \
	__asm pop	_n \
	__asm mov	eax, _n \
	__asm test	eax, eax \
	__asm jnz	$+45 \
	__asm push 	dpl+2 \
	__asm push 	sn \
	__asm call	getmemr \
	__asm add	esp, 8 \
	__asm mov	_n, eax \
	__asm push 	dpl+1 \
	__asm push 	sn \
	__asm call	getmemr \
	__asm add	esp, 8 \
	__asm mov	_dpl, eax \
	__asm mov	eax, _n \
	__asm mov	_i, 0 \
	__asm cmp	eax, _i \
	__asm je	$+45 \
	__asm mov	eax, _i \
	__asm add	eax, _dpl \
	__asm push	eax \
	__asm push	sn \
	__asm call	getmemr \
	__asm add	esp, 8 \
	__asm push	eax \
	__asm inc	_i \
	__asm mov	eax, _n \
	__asm jmp	$-46

#define stnvar(sn, dpl) \
	__asm pop	eax \
	__asm mov	_dpl, dpl \
	__asm test	eax, eax \
	__asm jnz	$+45 \
	__asm push 	dpl+2 \
	__asm push 	sn \
	__asm call	getmemr \
	__asm add	esp, 8 \
	__asm mov	_n, eax \
	__asm push 	dpl+1 \
	__asm push 	sn \
	__asm call	getmemr \
	__asm add	esp, 8 \
	__asm mov	_dpl, eax \
	__asm mov	eax, _n \
	__asm test	eax, eax \
	__asm jz	$+39 \
	__asm dec	eax \
	__asm mov	_n, eax \
	__asm add	eax, _dpl \
	__asm push	eax \
	__asm push	sn \
	__asm call	putmemr \
	__asm add	esp, 12 \
	__asm mov	eax, _n \
	__asm jmp	$-36

#define popn(sn, dpl) \
	__asm pop	eax \
	__asm mov	_dpl, dpl \
	__asm test	eax, eax \
	__asm jnz	$+45 \
	__asm push 	dpl+2 \
	__asm push 	sn \
	__asm call	getmemr \
	__asm add	esp, 8 \
	__asm mov	_n, eax \
	__asm push 	dpl+1 \
	__asm push 	sn \
	__asm call	getmemr \
	__asm add	esp, 8 \
	__asm mov	_dpl, eax \
	__asm mov	eax, _n \
	__asm test	eax, eax \
	__asm jz	$+13 \
	__asm dec	eax \
	__asm pop	ebx \
	__asm jmp	$-10
