/*******************************************************************************
* Interface file of code generation actions which is included in a parser
* generated with SLADE
*
* JHG sep97 SLADE Copyright (C) 1991-1997 University of Twente
*******************************************************************************/
#ifndef VIMCODE_H
#define VIMCODE_H

#include "cgl.h"
#include "idscope.h"

typedef enum {
	abs_, add, and, dvi, eq, ge, gt, jiff, jift, jump,
	le, lt, mdl, mul, ne, neg, noop, not, or, pop, sub, swap
} operation;

char *i_operation_text		(operation op);

void assign_op				(operation *dest, operation source);
void clear_op				(operation *dest);

void int_repr_bool			(integer *dest, boolean src);
void int_repr_char			(integer *dest, char src);
void int_repr_string		(integer *dest, string src);

void dy_op_bool				(boolean *dest, operation op, boolean src);
void dy_op_char				(char *dest, operation op, char src);
void dy_op_int				(integer *dest, operation op, integer src);
void dy_op_real				(real *dest, operation op, real src);

void finalise_vimcode		(void);

void get_index				(integer *index);
void get_label				(integer *labnr);

void initialise_vimcode		(void);

void emit_bound				(integer dim, def_ptr def);
void emit_call				(def_ptr def);
void emit_crseg				(integer level, integer index);
void emit_descr				(int sn, int dpl, int dim);
void emit_dlseg				(void);
void emit_xvaraddr			(def_ptr def);
void emit_jump				(operation instr, integer labnr);
void emit_label				(integer labnr);
void emit_ldcon				(integer arg);
void emit_load				(def_ptr def, e_access a, boolean setcheck);
void emit_op				(operation instr);
void emit_opn				(operation op, def_ptr def);
void emit_read				(e_type t);
void emit_return			(void);
void emit_stargs			(def_ptr def);
void emit_store				(def_ptr def, boolean load);
void emit_swap_pop			(def_ptr def, boolean truthval, e_access a);
void emit_write				(e_type t);

void enter_length			(integer index, integer value);

void mon_op_bool			(boolean *dest, operation op);
void mon_op_char			(char *dest, operation op);
void mon_op_int				(integer *dest, operation op);
void mon_op_real			(real *dest, operation op);

void update_dpl				(integer *, def_ptr);

#endif /*VIMCODE_H*/
