(*******************************************************************************
* Interface of code generation actions for the SLADE VIM code interpreter, to be
* included in a (batch oriented) SLADE parser specification
*
* JHG sep97 Copyright (C) 1991-1997 University of Twente
*******************************************************************************)

TYPES
    operation =(
		abs_, add, and, dvi, eq, ge, gt, jiff, jift, jump,
		le, lt, mdl, mul, ne, neg, noop, not, or, pop, sub, swap
    ).

ACTIONS
    assign_op          (out dest: operation; in src: operation).
    clear_op           (out dest: operation).
    dy_op_bool         (out dest: boolean;   in op: operation; in src: boolean).
    dy_op_char         (out dest: boolean;   in op: operation; in src: char).
    dy_op_int          (out dest: integer;   in op: operation; in src: integer).
    dy_op_real         (out dest: real;      in op: operation; in src: real).
    emit_bound         (in dim: integer;     in def: def_ptr).
    emit_call          (in ldef: def_ptr).
    emit_crseg         (in level: integer;   in len_index: integer).
    emit_descr         (in sn: integer;      in dpl: integer;  in dim: integer).
    emit_dlseg         ().
    emit_jump          (in instr: operation; in index: integer).
    emit_label         (in labelnr: integer).
    emit_ldcon         (in arg: integer).
    emit_load          (in def: def_ptr;     in a: e_access;
                                             in setcheck: boolean).
    emit_op            (in instr: operation).
    emit_opn           (in op: operation;    in def: def_ptr).
    emit_read          (in t: e_type).
    emit_return        ().
    emit_stargs        (in def: def_ptr).
    emit_store         (in def: def_ptr;     in load: boolean).
    emit_swap_pop      (in def: def_ptr;     in truthval: boolean;
                        in a: e_access).
    emit_write         (in t: e_type).
    emit_xvaraddr      (in def: def_ptr).
    enter_length       (in index: integer;   in value: integer).
    finalise_vimcode   ().
    get_index          (out index: integer).
    get_label          (out labnr: integer).
    initialise_vimcode ().
    int_repr_bool      (out dest: integer;   in src: boolean).
    int_repr_char      (out dest: integer;   in src: char).
    int_repr_string    (out dest: integer;   in src: string).
    mon_op_bool        (out dest: boolean;   in op: operation).
    mon_op_char        (out dest: char;      in op: operation).
    mon_op_int         (out dest: integer;   in op: operation).
    mon_op_real        (out dest: real;      in op: operation).
